# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### ApiGatewayToLambda <a name="ApiGatewayToLambda" id="must-cdk.ApiGatewayToLambda"></a>

Enhanced API Gateway to Lambda construct supporting both proxy and manual routing.

#### Initializers <a name="Initializers" id="must-cdk.ApiGatewayToLambda.Initializer"></a>

```typescript
import { ApiGatewayToLambda } from 'must-cdk'

new ApiGatewayToLambda(scope: Construct, id: string, props: ApiGatewayToLambdaProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.ApiGatewayToLambda.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambda.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambda.Initializer.parameter.props">props</a></code> | <code><a href="#must-cdk.ApiGatewayToLambdaProps">ApiGatewayToLambdaProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="must-cdk.ApiGatewayToLambda.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="must-cdk.ApiGatewayToLambda.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="must-cdk.ApiGatewayToLambda.Initializer.parameter.props"></a>

- *Type:* <a href="#must-cdk.ApiGatewayToLambdaProps">ApiGatewayToLambdaProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.ApiGatewayToLambda.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#must-cdk.ApiGatewayToLambda.addRoute">addRoute</a></code> | Add a custom route after construction (for dynamic route addition). |

---

##### `toString` <a name="toString" id="must-cdk.ApiGatewayToLambda.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addRoute` <a name="addRoute" id="must-cdk.ApiGatewayToLambda.addRoute"></a>

```typescript
public addRoute(route: CustomRoute): Method
```

Add a custom route after construction (for dynamic route addition).

###### `route`<sup>Required</sup> <a name="route" id="must-cdk.ApiGatewayToLambda.addRoute.parameter.route"></a>

- *Type:* <a href="#must-cdk.CustomRoute">CustomRoute</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.ApiGatewayToLambda.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="must-cdk.ApiGatewayToLambda.isConstruct"></a>

```typescript
import { ApiGatewayToLambda } from 'must-cdk'

ApiGatewayToLambda.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="must-cdk.ApiGatewayToLambda.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.ApiGatewayToLambda.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#must-cdk.ApiGatewayToLambda.property.apiGateway">apiGateway</a></code> | <code>aws-cdk-lib.aws_apigateway.RestApi</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambda.property.apiUrl">apiUrl</a></code> | <code>string</code> | Get the API Gateway URL (useful for outputs). |
| <code><a href="#must-cdk.ApiGatewayToLambda.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambda.property.apiGatewayCloudWatchRole">apiGatewayCloudWatchRole</a></code> | <code>aws-cdk-lib.aws_iam.Role</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambda.property.apiGatewayLogGroup">apiGatewayLogGroup</a></code> | <code>aws-cdk-lib.aws_logs.LogGroup</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambda.property.aRecord">aRecord</a></code> | <code>aws-cdk-lib.aws_route53.ARecord</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambda.property.certificate">certificate</a></code> | <code>aws-cdk-lib.aws_certificatemanager.ICertificate</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambda.property.domain">domain</a></code> | <code>aws-cdk-lib.aws_apigateway.DomainName</code> | *No description.* |
| <code><a href="#must-cdk.ApiGatewayToLambda.property.usagePlan">usagePlan</a></code> | <code>aws-cdk-lib.aws_apigateway.UsagePlan</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="must-cdk.ApiGatewayToLambda.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGateway`<sup>Required</sup> <a name="apiGateway" id="must-cdk.ApiGatewayToLambda.property.apiGateway"></a>

```typescript
public readonly apiGateway: RestApi;
```

- *Type:* aws-cdk-lib.aws_apigateway.RestApi

---

##### `apiUrl`<sup>Required</sup> <a name="apiUrl" id="must-cdk.ApiGatewayToLambda.property.apiUrl"></a>

```typescript
public readonly apiUrl: string;
```

- *Type:* string

Get the API Gateway URL (useful for outputs).

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="must-cdk.ApiGatewayToLambda.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

##### `apiGatewayCloudWatchRole`<sup>Optional</sup> <a name="apiGatewayCloudWatchRole" id="must-cdk.ApiGatewayToLambda.property.apiGatewayCloudWatchRole"></a>

```typescript
public readonly apiGatewayCloudWatchRole: Role;
```

- *Type:* aws-cdk-lib.aws_iam.Role

---

##### `apiGatewayLogGroup`<sup>Optional</sup> <a name="apiGatewayLogGroup" id="must-cdk.ApiGatewayToLambda.property.apiGatewayLogGroup"></a>

```typescript
public readonly apiGatewayLogGroup: LogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.LogGroup

---

##### `aRecord`<sup>Optional</sup> <a name="aRecord" id="must-cdk.ApiGatewayToLambda.property.aRecord"></a>

```typescript
public readonly aRecord: ARecord;
```

- *Type:* aws-cdk-lib.aws_route53.ARecord

---

##### `certificate`<sup>Optional</sup> <a name="certificate" id="must-cdk.ApiGatewayToLambda.property.certificate"></a>

```typescript
public readonly certificate: ICertificate;
```

- *Type:* aws-cdk-lib.aws_certificatemanager.ICertificate

---

##### `domain`<sup>Optional</sup> <a name="domain" id="must-cdk.ApiGatewayToLambda.property.domain"></a>

```typescript
public readonly domain: DomainName;
```

- *Type:* aws-cdk-lib.aws_apigateway.DomainName

---

##### `usagePlan`<sup>Optional</sup> <a name="usagePlan" id="must-cdk.ApiGatewayToLambda.property.usagePlan"></a>

```typescript
public readonly usagePlan: UsagePlan;
```

- *Type:* aws-cdk-lib.aws_apigateway.UsagePlan

---


### EcsCodeDeploy <a name="EcsCodeDeploy" id="must-cdk.EcsCodeDeploy"></a>

#### Initializers <a name="Initializers" id="must-cdk.EcsCodeDeploy.Initializer"></a>

```typescript
import { EcsCodeDeploy } from 'must-cdk'

new EcsCodeDeploy(scope: Construct, id: string, props: EcsCodeDeployProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.EcsCodeDeploy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.Initializer.parameter.props">props</a></code> | <code><a href="#must-cdk.EcsCodeDeployProps">EcsCodeDeployProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="must-cdk.EcsCodeDeploy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="must-cdk.EcsCodeDeploy.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="must-cdk.EcsCodeDeploy.Initializer.parameter.props"></a>

- *Type:* <a href="#must-cdk.EcsCodeDeployProps">EcsCodeDeployProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.EcsCodeDeploy.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#must-cdk.EcsCodeDeploy.allListeners">allListeners</a></code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.blueListener">blueListener</a></code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.greenListener">greenListener</a></code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.loadBalancerDnsName">loadBalancerDnsName</a></code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.serviceArn">serviceArn</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="must-cdk.EcsCodeDeploy.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `allListeners` <a name="allListeners" id="must-cdk.EcsCodeDeploy.allListeners"></a>

```typescript
public allListeners(): ApplicationListener[]
```

##### `blueListener` <a name="blueListener" id="must-cdk.EcsCodeDeploy.blueListener"></a>

```typescript
public blueListener(): ApplicationListener
```

##### `greenListener` <a name="greenListener" id="must-cdk.EcsCodeDeploy.greenListener"></a>

```typescript
public greenListener(): ApplicationListener
```

##### `loadBalancerDnsName` <a name="loadBalancerDnsName" id="must-cdk.EcsCodeDeploy.loadBalancerDnsName"></a>

```typescript
public loadBalancerDnsName(): string
```

##### `serviceArn` <a name="serviceArn" id="must-cdk.EcsCodeDeploy.serviceArn"></a>

```typescript
public serviceArn(): string
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.EcsCodeDeploy.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="must-cdk.EcsCodeDeploy.isConstruct"></a>

```typescript
import { EcsCodeDeploy } from 'must-cdk'

EcsCodeDeploy.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="must-cdk.EcsCodeDeploy.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.EcsCodeDeploy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#must-cdk.EcsCodeDeploy.property.blueTargetGroup">blueTargetGroup</a></code> | <code>aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.property.codeDeployApp">codeDeployApp</a></code> | <code>aws-cdk-lib.aws_codedeploy.EcsApplication</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.property.greenTargetGroup">greenTargetGroup</a></code> | <code>aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.property.loadBalancer">loadBalancer</a></code> | <code>aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.property.service">service</a></code> | <code>aws-cdk-lib.aws_ecs.FargateService</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.property.taskDef">taskDef</a></code> | <code>aws-cdk-lib.aws_ecs.TaskDefinition</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.property.taskExecutionRole">taskExecutionRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeploy.property.taskRole">taskRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="must-cdk.EcsCodeDeploy.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `blueTargetGroup`<sup>Required</sup> <a name="blueTargetGroup" id="must-cdk.EcsCodeDeploy.property.blueTargetGroup"></a>

```typescript
public readonly blueTargetGroup: ApplicationTargetGroup;
```

- *Type:* aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup

---

##### `codeDeployApp`<sup>Required</sup> <a name="codeDeployApp" id="must-cdk.EcsCodeDeploy.property.codeDeployApp"></a>

```typescript
public readonly codeDeployApp: EcsApplication;
```

- *Type:* aws-cdk-lib.aws_codedeploy.EcsApplication

---

##### `greenTargetGroup`<sup>Required</sup> <a name="greenTargetGroup" id="must-cdk.EcsCodeDeploy.property.greenTargetGroup"></a>

```typescript
public readonly greenTargetGroup: ApplicationTargetGroup;
```

- *Type:* aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup

---

##### `loadBalancer`<sup>Required</sup> <a name="loadBalancer" id="must-cdk.EcsCodeDeploy.property.loadBalancer"></a>

```typescript
public readonly loadBalancer: ApplicationLoadBalancer;
```

- *Type:* aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer

---

##### `service`<sup>Required</sup> <a name="service" id="must-cdk.EcsCodeDeploy.property.service"></a>

```typescript
public readonly service: FargateService;
```

- *Type:* aws-cdk-lib.aws_ecs.FargateService

---

##### `taskDef`<sup>Required</sup> <a name="taskDef" id="must-cdk.EcsCodeDeploy.property.taskDef"></a>

```typescript
public readonly taskDef: TaskDefinition;
```

- *Type:* aws-cdk-lib.aws_ecs.TaskDefinition

---

##### `taskExecutionRole`<sup>Required</sup> <a name="taskExecutionRole" id="must-cdk.EcsCodeDeploy.property.taskExecutionRole"></a>

```typescript
public readonly taskExecutionRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---

##### `taskRole`<sup>Required</sup> <a name="taskRole" id="must-cdk.EcsCodeDeploy.property.taskRole"></a>

```typescript
public readonly taskRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---


### WebSocketApiGatewayToLambda <a name="WebSocketApiGatewayToLambda" id="must-cdk.WebSocketApiGatewayToLambda"></a>

Enhanced WebSocket API Gateway to Lambda construct.

#### Initializers <a name="Initializers" id="must-cdk.WebSocketApiGatewayToLambda.Initializer"></a>

```typescript
import { WebSocketApiGatewayToLambda } from 'must-cdk'

new WebSocketApiGatewayToLambda(scope: Construct, id: string, props: WebSocketApiGatewayToLambdaProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.Initializer.parameter.props">props</a></code> | <code><a href="#must-cdk.WebSocketApiGatewayToLambdaProps">WebSocketApiGatewayToLambdaProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="must-cdk.WebSocketApiGatewayToLambda.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="must-cdk.WebSocketApiGatewayToLambda.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="must-cdk.WebSocketApiGatewayToLambda.Initializer.parameter.props"></a>

- *Type:* <a href="#must-cdk.WebSocketApiGatewayToLambdaProps">WebSocketApiGatewayToLambdaProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.addRoute">addRoute</a></code> | Add a custom route after construction (for dynamic route addition). |

---

##### `toString` <a name="toString" id="must-cdk.WebSocketApiGatewayToLambda.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addRoute` <a name="addRoute" id="must-cdk.WebSocketApiGatewayToLambda.addRoute"></a>

```typescript
public addRoute(route: WebSocketRoute): WebSocketRoute
```

Add a custom route after construction (for dynamic route addition).

###### `route`<sup>Required</sup> <a name="route" id="must-cdk.WebSocketApiGatewayToLambda.addRoute.parameter.route"></a>

- *Type:* <a href="#must-cdk.WebSocketRoute">WebSocketRoute</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="must-cdk.WebSocketApiGatewayToLambda.isConstruct"></a>

```typescript
import { WebSocketApiGatewayToLambda } from 'must-cdk'

WebSocketApiGatewayToLambda.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="must-cdk.WebSocketApiGatewayToLambda.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.property.webSocketApi">webSocketApi</a></code> | <code>aws-cdk-lib.aws_apigatewayv2.WebSocketApi</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.property.webSocketStage">webSocketStage</a></code> | <code>aws-cdk-lib.aws_apigatewayv2.WebSocketStage</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.property.webSocketUrl">webSocketUrl</a></code> | <code>string</code> | Get the WebSocket API URL (useful for outputs). |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.property.apiGatewayCloudWatchRole">apiGatewayCloudWatchRole</a></code> | <code>aws-cdk-lib.aws_iam.Role</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.property.apiGatewayLogGroup">apiGatewayLogGroup</a></code> | <code>aws-cdk-lib.aws_logs.LogGroup</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.property.aRecord">aRecord</a></code> | <code>aws-cdk-lib.aws_route53.ARecord</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.property.certificate">certificate</a></code> | <code>aws-cdk-lib.aws_certificatemanager.ICertificate</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambda.property.domain">domain</a></code> | <code>aws-cdk-lib.aws_apigatewayv2.DomainName</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="must-cdk.WebSocketApiGatewayToLambda.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="must-cdk.WebSocketApiGatewayToLambda.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

##### `webSocketApi`<sup>Required</sup> <a name="webSocketApi" id="must-cdk.WebSocketApiGatewayToLambda.property.webSocketApi"></a>

```typescript
public readonly webSocketApi: WebSocketApi;
```

- *Type:* aws-cdk-lib.aws_apigatewayv2.WebSocketApi

---

##### `webSocketStage`<sup>Required</sup> <a name="webSocketStage" id="must-cdk.WebSocketApiGatewayToLambda.property.webSocketStage"></a>

```typescript
public readonly webSocketStage: WebSocketStage;
```

- *Type:* aws-cdk-lib.aws_apigatewayv2.WebSocketStage

---

##### `webSocketUrl`<sup>Required</sup> <a name="webSocketUrl" id="must-cdk.WebSocketApiGatewayToLambda.property.webSocketUrl"></a>

```typescript
public readonly webSocketUrl: string;
```

- *Type:* string

Get the WebSocket API URL (useful for outputs).

---

##### `apiGatewayCloudWatchRole`<sup>Optional</sup> <a name="apiGatewayCloudWatchRole" id="must-cdk.WebSocketApiGatewayToLambda.property.apiGatewayCloudWatchRole"></a>

```typescript
public readonly apiGatewayCloudWatchRole: Role;
```

- *Type:* aws-cdk-lib.aws_iam.Role

---

##### `apiGatewayLogGroup`<sup>Optional</sup> <a name="apiGatewayLogGroup" id="must-cdk.WebSocketApiGatewayToLambda.property.apiGatewayLogGroup"></a>

```typescript
public readonly apiGatewayLogGroup: LogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.LogGroup

---

##### `aRecord`<sup>Optional</sup> <a name="aRecord" id="must-cdk.WebSocketApiGatewayToLambda.property.aRecord"></a>

```typescript
public readonly aRecord: ARecord;
```

- *Type:* aws-cdk-lib.aws_route53.ARecord

---

##### `certificate`<sup>Optional</sup> <a name="certificate" id="must-cdk.WebSocketApiGatewayToLambda.property.certificate"></a>

```typescript
public readonly certificate: ICertificate;
```

- *Type:* aws-cdk-lib.aws_certificatemanager.ICertificate

---

##### `domain`<sup>Optional</sup> <a name="domain" id="must-cdk.WebSocketApiGatewayToLambda.property.domain"></a>

```typescript
public readonly domain: DomainName;
```

- *Type:* aws-cdk-lib.aws_apigatewayv2.DomainName

---


## Structs <a name="Structs" id="Structs"></a>

### ApiGatewayToLambdaProps <a name="ApiGatewayToLambdaProps" id="must-cdk.ApiGatewayToLambdaProps"></a>

#### Initializer <a name="Initializer" id="must-cdk.ApiGatewayToLambdaProps.Initializer"></a>

```typescript
import { ApiGatewayToLambdaProps } from 'must-cdk'

const apiGatewayToLambdaProps: ApiGatewayToLambdaProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.apiGateway">apiGateway</a></code> | <code><a href="#must-cdk.ApiProps">ApiProps</a></code> | API configuration. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | Primary Lambda function for the API. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.certificateArn">certificateArn</a></code> | <code>string</code> | Optional ACM certificate ARN to use instead of creating a new one. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.createUsagePlan">createUsagePlan</a></code> | <code>boolean</code> | Whether to create a Usage Plan. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.customDomainName">customDomainName</a></code> | <code>string</code> | Optional custom domain name for API Gateway. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.customRoutes">customRoutes</a></code> | <code><a href="#must-cdk.CustomRoute">CustomRoute</a>[]</code> | Custom routes for manual API setup (when proxy is false) If provided, will use RestApi instead of LambdaRestApi. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.enableLogging">enableLogging</a></code> | <code>boolean</code> | Enable CloudWatch logging for API Gateway. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.hostedZone">hostedZone</a></code> | <code>aws-cdk-lib.aws_route53.IHostedZone</code> | Optional Route53 hosted zone for custom domain. |
| <code><a href="#must-cdk.ApiGatewayToLambdaProps.property.logGroupProps">logGroupProps</a></code> | <code>aws-cdk-lib.aws_logs.LogGroupProps</code> | CloudWatch Logs configuration. |

---

##### `apiGateway`<sup>Required</sup> <a name="apiGateway" id="must-cdk.ApiGatewayToLambdaProps.property.apiGateway"></a>

```typescript
public readonly apiGateway: ApiProps;
```

- *Type:* <a href="#must-cdk.ApiProps">ApiProps</a>

API configuration.

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="must-cdk.ApiGatewayToLambdaProps.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

Primary Lambda function for the API.

---

##### `certificateArn`<sup>Optional</sup> <a name="certificateArn" id="must-cdk.ApiGatewayToLambdaProps.property.certificateArn"></a>

```typescript
public readonly certificateArn: string;
```

- *Type:* string

Optional ACM certificate ARN to use instead of creating a new one.

---

##### `createUsagePlan`<sup>Optional</sup> <a name="createUsagePlan" id="must-cdk.ApiGatewayToLambdaProps.property.createUsagePlan"></a>

```typescript
public readonly createUsagePlan: boolean;
```

- *Type:* boolean

Whether to create a Usage Plan.

---

##### `customDomainName`<sup>Optional</sup> <a name="customDomainName" id="must-cdk.ApiGatewayToLambdaProps.property.customDomainName"></a>

```typescript
public readonly customDomainName: string;
```

- *Type:* string

Optional custom domain name for API Gateway.

---

##### `customRoutes`<sup>Optional</sup> <a name="customRoutes" id="must-cdk.ApiGatewayToLambdaProps.property.customRoutes"></a>

```typescript
public readonly customRoutes: CustomRoute[];
```

- *Type:* <a href="#must-cdk.CustomRoute">CustomRoute</a>[]

Custom routes for manual API setup (when proxy is false) If provided, will use RestApi instead of LambdaRestApi.

---

##### `enableLogging`<sup>Optional</sup> <a name="enableLogging" id="must-cdk.ApiGatewayToLambdaProps.property.enableLogging"></a>

```typescript
public readonly enableLogging: boolean;
```

- *Type:* boolean

Enable CloudWatch logging for API Gateway.

---

##### `hostedZone`<sup>Optional</sup> <a name="hostedZone" id="must-cdk.ApiGatewayToLambdaProps.property.hostedZone"></a>

```typescript
public readonly hostedZone: IHostedZone;
```

- *Type:* aws-cdk-lib.aws_route53.IHostedZone

Optional Route53 hosted zone for custom domain.

---

##### `logGroupProps`<sup>Optional</sup> <a name="logGroupProps" id="must-cdk.ApiGatewayToLambdaProps.property.logGroupProps"></a>

```typescript
public readonly logGroupProps: LogGroupProps;
```

- *Type:* aws-cdk-lib.aws_logs.LogGroupProps

CloudWatch Logs configuration.

---

### ApiProps <a name="ApiProps" id="must-cdk.ApiProps"></a>

#### Initializer <a name="Initializer" id="must-cdk.ApiProps.Initializer"></a>

```typescript
import { ApiProps } from 'must-cdk'

const apiProps: ApiProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.ApiProps.property.apiName">apiName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#must-cdk.ApiProps.property.lambdaApiProps">lambdaApiProps</a></code> | <code>aws-cdk-lib.aws_apigateway.LambdaRestApiProps</code> | *No description.* |
| <code><a href="#must-cdk.ApiProps.property.proxy">proxy</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#must-cdk.ApiProps.property.restApiProps">restApiProps</a></code> | <code>aws-cdk-lib.aws_apigateway.RestApiProps</code> | *No description.* |

---

##### `apiName`<sup>Required</sup> <a name="apiName" id="must-cdk.ApiProps.property.apiName"></a>

```typescript
public readonly apiName: string;
```

- *Type:* string

---

##### `lambdaApiProps`<sup>Optional</sup> <a name="lambdaApiProps" id="must-cdk.ApiProps.property.lambdaApiProps"></a>

```typescript
public readonly lambdaApiProps: LambdaRestApiProps;
```

- *Type:* aws-cdk-lib.aws_apigateway.LambdaRestApiProps

---

##### `proxy`<sup>Optional</sup> <a name="proxy" id="must-cdk.ApiProps.property.proxy"></a>

```typescript
public readonly proxy: boolean;
```

- *Type:* boolean

---

##### `restApiProps`<sup>Optional</sup> <a name="restApiProps" id="must-cdk.ApiProps.property.restApiProps"></a>

```typescript
public readonly restApiProps: RestApiProps;
```

- *Type:* aws-cdk-lib.aws_apigateway.RestApiProps

---

### AutoScalingProps <a name="AutoScalingProps" id="must-cdk.AutoScalingProps"></a>

Configuration for ECS service auto-scaling.

#### Initializer <a name="Initializer" id="must-cdk.AutoScalingProps.Initializer"></a>

```typescript
import { AutoScalingProps } from 'must-cdk'

const autoScalingProps: AutoScalingProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.AutoScalingProps.property.maxCapacity">maxCapacity</a></code> | <code>number</code> | Maximum number of tasks to run. |
| <code><a href="#must-cdk.AutoScalingProps.property.minCapacity">minCapacity</a></code> | <code>number</code> | Minimum number of tasks to run. |
| <code><a href="#must-cdk.AutoScalingProps.property.cpuScale">cpuScale</a></code> | <code>aws-cdk-lib.aws_ecs.CpuUtilizationScalingProps</code> | Scale task based on CPU utilization. |
| <code><a href="#must-cdk.AutoScalingProps.property.memoryScale">memoryScale</a></code> | <code>aws-cdk-lib.aws_ecs.MemoryUtilizationScalingProps</code> | Scale task based on memory utilization. |

---

##### `maxCapacity`<sup>Required</sup> <a name="maxCapacity" id="must-cdk.AutoScalingProps.property.maxCapacity"></a>

```typescript
public readonly maxCapacity: number;
```

- *Type:* number

Maximum number of tasks to run.

---

##### `minCapacity`<sup>Required</sup> <a name="minCapacity" id="must-cdk.AutoScalingProps.property.minCapacity"></a>

```typescript
public readonly minCapacity: number;
```

- *Type:* number

Minimum number of tasks to run.

---

##### `cpuScale`<sup>Optional</sup> <a name="cpuScale" id="must-cdk.AutoScalingProps.property.cpuScale"></a>

```typescript
public readonly cpuScale: CpuUtilizationScalingProps;
```

- *Type:* aws-cdk-lib.aws_ecs.CpuUtilizationScalingProps

Scale task based on CPU utilization.

---

##### `memoryScale`<sup>Optional</sup> <a name="memoryScale" id="must-cdk.AutoScalingProps.property.memoryScale"></a>

```typescript
public readonly memoryScale: MemoryUtilizationScalingProps;
```

- *Type:* aws-cdk-lib.aws_ecs.MemoryUtilizationScalingProps

Scale task based on memory utilization.

---

### ContainerProps <a name="ContainerProps" id="must-cdk.ContainerProps"></a>

Configuration for the ECS Fargate task definition and container.

#### Initializer <a name="Initializer" id="must-cdk.ContainerProps.Initializer"></a>

```typescript
import { ContainerProps } from 'must-cdk'

const containerProps: ContainerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.ContainerProps.property.containerPort">containerPort</a></code> | <code>number</code> | The port number the container listens on. |
| <code><a href="#must-cdk.ContainerProps.property.image">image</a></code> | <code>aws-cdk-lib.aws_ecs.ContainerImage</code> | Container image to deploy. |
| <code><a href="#must-cdk.ContainerProps.property.healthCheck">healthCheck</a></code> | <code>aws-cdk-lib.aws_ecs.HealthCheck</code> | Optional container health check configuration. |
| <code><a href="#must-cdk.ContainerProps.property.memoryLimit">memoryLimit</a></code> | <code>number</code> | Hard memory limit in MiB for the task (default: 2048). |
| <code><a href="#must-cdk.ContainerProps.property.memoryReservation">memoryReservation</a></code> | <code>number</code> | Soft memory reservation in MiB for the container (default: 1024). |

---

##### `containerPort`<sup>Required</sup> <a name="containerPort" id="must-cdk.ContainerProps.property.containerPort"></a>

```typescript
public readonly containerPort: number;
```

- *Type:* number

The port number the container listens on.

---

##### `image`<sup>Required</sup> <a name="image" id="must-cdk.ContainerProps.property.image"></a>

```typescript
public readonly image: ContainerImage;
```

- *Type:* aws-cdk-lib.aws_ecs.ContainerImage

Container image to deploy.

---

##### `healthCheck`<sup>Optional</sup> <a name="healthCheck" id="must-cdk.ContainerProps.property.healthCheck"></a>

```typescript
public readonly healthCheck: HealthCheck;
```

- *Type:* aws-cdk-lib.aws_ecs.HealthCheck

Optional container health check configuration.

---

##### `memoryLimit`<sup>Optional</sup> <a name="memoryLimit" id="must-cdk.ContainerProps.property.memoryLimit"></a>

```typescript
public readonly memoryLimit: number;
```

- *Type:* number

Hard memory limit in MiB for the task (default: 2048).

---

##### `memoryReservation`<sup>Optional</sup> <a name="memoryReservation" id="must-cdk.ContainerProps.property.memoryReservation"></a>

```typescript
public readonly memoryReservation: number;
```

- *Type:* number

Soft memory reservation in MiB for the container (default: 1024).

---

### CustomRoute <a name="CustomRoute" id="must-cdk.CustomRoute"></a>

#### Initializer <a name="Initializer" id="must-cdk.CustomRoute.Initializer"></a>

```typescript
import { CustomRoute } from 'must-cdk'

const customRoute: CustomRoute = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.CustomRoute.property.handler">handler</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | *No description.* |
| <code><a href="#must-cdk.CustomRoute.property.method">method</a></code> | <code>string</code> | *No description.* |
| <code><a href="#must-cdk.CustomRoute.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#must-cdk.CustomRoute.property.methodOptions">methodOptions</a></code> | <code>aws-cdk-lib.aws_apigateway.MethodOptions</code> | *No description.* |

---

##### `handler`<sup>Required</sup> <a name="handler" id="must-cdk.CustomRoute.property.handler"></a>

```typescript
public readonly handler: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

##### `method`<sup>Required</sup> <a name="method" id="must-cdk.CustomRoute.property.method"></a>

```typescript
public readonly method: string;
```

- *Type:* string

---

##### `path`<sup>Required</sup> <a name="path" id="must-cdk.CustomRoute.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `methodOptions`<sup>Optional</sup> <a name="methodOptions" id="must-cdk.CustomRoute.property.methodOptions"></a>

```typescript
public readonly methodOptions: MethodOptions;
```

- *Type:* aws-cdk-lib.aws_apigateway.MethodOptions

---

### EcsCodeDeployProps <a name="EcsCodeDeployProps" id="must-cdk.EcsCodeDeployProps"></a>

Properties for the EcsCodeDeploy construct.

#### Initializer <a name="Initializer" id="must-cdk.EcsCodeDeployProps.Initializer"></a>

```typescript
import { EcsCodeDeployProps } from 'must-cdk'

const ecsCodeDeployProps: EcsCodeDeployProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.certificates">certificates</a></code> | <code>aws-cdk-lib.aws_certificatemanager.ICertificate[]</code> | Optional ACM certificates for HTTPS termination. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_ecs.ICluster</code> | ECS Cluster where the service will run. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.containers">containers</a></code> | <code><a href="#must-cdk.ContainerProps">ContainerProps</a>[]</code> | Configuration related to the task definition and container. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.securityGroups">securityGroups</a></code> | <code>aws-cdk-lib.aws_ec2.ISecurityGroup[]</code> | Security group config. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.serviceName">serviceName</a></code> | <code>string</code> | Base name used for resources like log groups, roles, services, etc. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.subnets">subnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | Select which subnets the Service and ALB will placed on. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | VPC in which to deploy ECS and ALB resources. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.albTargetPort">albTargetPort</a></code> | <code>number</code> | The ALB target port. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.autoScaling">autoScaling</a></code> | <code><a href="#must-cdk.AutoScalingProps">AutoScalingProps</a></code> | Optional auto-scaling configuration. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.enablePublicLoadBalancer">enablePublicLoadBalancer</a></code> | <code>boolean</code> | Whether the load balancer should be internet-facing (default: false). |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.memoryLimit">memoryLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.taskCPU">taskCPU</a></code> | <code>number</code> | CPU units for the task (default: 1024). |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.taskExecRole">taskExecRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | Task execution role for the ECS task. |
| <code><a href="#must-cdk.EcsCodeDeployProps.property.taskRole">taskRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | Task role for the ECS task. |

---

##### `certificates`<sup>Required</sup> <a name="certificates" id="must-cdk.EcsCodeDeployProps.property.certificates"></a>

```typescript
public readonly certificates: ICertificate[];
```

- *Type:* aws-cdk-lib.aws_certificatemanager.ICertificate[]

Optional ACM certificates for HTTPS termination.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="must-cdk.EcsCodeDeployProps.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_ecs.ICluster

ECS Cluster where the service will run.

---

##### `containers`<sup>Required</sup> <a name="containers" id="must-cdk.EcsCodeDeployProps.property.containers"></a>

```typescript
public readonly containers: ContainerProps[];
```

- *Type:* <a href="#must-cdk.ContainerProps">ContainerProps</a>[]

Configuration related to the task definition and container.

---

##### `securityGroups`<sup>Required</sup> <a name="securityGroups" id="must-cdk.EcsCodeDeployProps.property.securityGroups"></a>

```typescript
public readonly securityGroups: ISecurityGroup[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISecurityGroup[]

Security group config.

---

##### `serviceName`<sup>Required</sup> <a name="serviceName" id="must-cdk.EcsCodeDeployProps.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

Base name used for resources like log groups, roles, services, etc.

---

##### `subnets`<sup>Required</sup> <a name="subnets" id="must-cdk.EcsCodeDeployProps.property.subnets"></a>

```typescript
public readonly subnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

Select which subnets the Service and ALB will placed on.

---

##### `vpc`<sup>Required</sup> <a name="vpc" id="must-cdk.EcsCodeDeployProps.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

VPC in which to deploy ECS and ALB resources.

---

##### `albTargetPort`<sup>Optional</sup> <a name="albTargetPort" id="must-cdk.EcsCodeDeployProps.property.albTargetPort"></a>

```typescript
public readonly albTargetPort: number;
```

- *Type:* number

The ALB target port.

---

##### `autoScaling`<sup>Optional</sup> <a name="autoScaling" id="must-cdk.EcsCodeDeployProps.property.autoScaling"></a>

```typescript
public readonly autoScaling: AutoScalingProps;
```

- *Type:* <a href="#must-cdk.AutoScalingProps">AutoScalingProps</a>

Optional auto-scaling configuration.

---

##### `enablePublicLoadBalancer`<sup>Optional</sup> <a name="enablePublicLoadBalancer" id="must-cdk.EcsCodeDeployProps.property.enablePublicLoadBalancer"></a>

```typescript
public readonly enablePublicLoadBalancer: boolean;
```

- *Type:* boolean

Whether the load balancer should be internet-facing (default: false).

---

##### `memoryLimit`<sup>Optional</sup> <a name="memoryLimit" id="must-cdk.EcsCodeDeployProps.property.memoryLimit"></a>

```typescript
public readonly memoryLimit: number;
```

- *Type:* number

---

##### `taskCPU`<sup>Optional</sup> <a name="taskCPU" id="must-cdk.EcsCodeDeployProps.property.taskCPU"></a>

```typescript
public readonly taskCPU: number;
```

- *Type:* number

CPU units for the task (default: 1024).

---

##### `taskExecRole`<sup>Optional</sup> <a name="taskExecRole" id="must-cdk.EcsCodeDeployProps.property.taskExecRole"></a>

```typescript
public readonly taskExecRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

Task execution role for the ECS task.

---

##### `taskRole`<sup>Optional</sup> <a name="taskRole" id="must-cdk.EcsCodeDeployProps.property.taskRole"></a>

```typescript
public readonly taskRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

Task role for the ECS task.

---

### WebSocketApiGatewayToLambdaProps <a name="WebSocketApiGatewayToLambdaProps" id="must-cdk.WebSocketApiGatewayToLambdaProps"></a>

#### Initializer <a name="Initializer" id="must-cdk.WebSocketApiGatewayToLambdaProps.Initializer"></a>

```typescript
import { WebSocketApiGatewayToLambdaProps } from 'must-cdk'

const webSocketApiGatewayToLambdaProps: WebSocketApiGatewayToLambdaProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambdaProps.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | Primary Lambda function for the API (usually handles $default route). |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambdaProps.property.webSocketApi">webSocketApi</a></code> | <code><a href="#must-cdk.WebSocketApiProps">WebSocketApiProps</a></code> | WebSocket API configuration. |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambdaProps.property.certificateArn">certificateArn</a></code> | <code>string</code> | Optional ACM certificate ARN to use instead of creating a new one. |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambdaProps.property.customDomainName">customDomainName</a></code> | <code>string</code> | Optional custom domain name for API Gateway. |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambdaProps.property.customRoutes">customRoutes</a></code> | <code><a href="#must-cdk.WebSocketRoute">WebSocketRoute</a>[]</code> | Custom routes for WebSocket API Common routes: $connect, $disconnect, $default, or custom route keys. |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambdaProps.property.enableLogging">enableLogging</a></code> | <code>boolean</code> | Enable CloudWatch logging for API Gateway. |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambdaProps.property.hostedZone">hostedZone</a></code> | <code>aws-cdk-lib.aws_route53.IHostedZone</code> | Optional Route53 hosted zone for custom domain. |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambdaProps.property.logGroupProps">logGroupProps</a></code> | <code>aws-cdk-lib.aws_logs.LogGroupProps</code> | CloudWatch Logs configuration. |
| <code><a href="#must-cdk.WebSocketApiGatewayToLambdaProps.property.stageName">stageName</a></code> | <code>string</code> | Stage name for the WebSocket API. |

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="must-cdk.WebSocketApiGatewayToLambdaProps.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

Primary Lambda function for the API (usually handles $default route).

---

##### `webSocketApi`<sup>Required</sup> <a name="webSocketApi" id="must-cdk.WebSocketApiGatewayToLambdaProps.property.webSocketApi"></a>

```typescript
public readonly webSocketApi: WebSocketApiProps;
```

- *Type:* <a href="#must-cdk.WebSocketApiProps">WebSocketApiProps</a>

WebSocket API configuration.

---

##### `certificateArn`<sup>Optional</sup> <a name="certificateArn" id="must-cdk.WebSocketApiGatewayToLambdaProps.property.certificateArn"></a>

```typescript
public readonly certificateArn: string;
```

- *Type:* string

Optional ACM certificate ARN to use instead of creating a new one.

---

##### `customDomainName`<sup>Optional</sup> <a name="customDomainName" id="must-cdk.WebSocketApiGatewayToLambdaProps.property.customDomainName"></a>

```typescript
public readonly customDomainName: string;
```

- *Type:* string

Optional custom domain name for API Gateway.

---

##### `customRoutes`<sup>Optional</sup> <a name="customRoutes" id="must-cdk.WebSocketApiGatewayToLambdaProps.property.customRoutes"></a>

```typescript
public readonly customRoutes: WebSocketRoute[];
```

- *Type:* <a href="#must-cdk.WebSocketRoute">WebSocketRoute</a>[]

Custom routes for WebSocket API Common routes: $connect, $disconnect, $default, or custom route keys.

---

##### `enableLogging`<sup>Optional</sup> <a name="enableLogging" id="must-cdk.WebSocketApiGatewayToLambdaProps.property.enableLogging"></a>

```typescript
public readonly enableLogging: boolean;
```

- *Type:* boolean

Enable CloudWatch logging for API Gateway.

---

##### `hostedZone`<sup>Optional</sup> <a name="hostedZone" id="must-cdk.WebSocketApiGatewayToLambdaProps.property.hostedZone"></a>

```typescript
public readonly hostedZone: IHostedZone;
```

- *Type:* aws-cdk-lib.aws_route53.IHostedZone

Optional Route53 hosted zone for custom domain.

---

##### `logGroupProps`<sup>Optional</sup> <a name="logGroupProps" id="must-cdk.WebSocketApiGatewayToLambdaProps.property.logGroupProps"></a>

```typescript
public readonly logGroupProps: LogGroupProps;
```

- *Type:* aws-cdk-lib.aws_logs.LogGroupProps

CloudWatch Logs configuration.

---

##### `stageName`<sup>Optional</sup> <a name="stageName" id="must-cdk.WebSocketApiGatewayToLambdaProps.property.stageName"></a>

```typescript
public readonly stageName: string;
```

- *Type:* string
- *Default:* 'dev'

Stage name for the WebSocket API.

---

### WebSocketApiProps <a name="WebSocketApiProps" id="must-cdk.WebSocketApiProps"></a>

#### Initializer <a name="Initializer" id="must-cdk.WebSocketApiProps.Initializer"></a>

```typescript
import { WebSocketApiProps } from 'must-cdk'

const webSocketApiProps: WebSocketApiProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.WebSocketApiProps.property.apiName">apiName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketApiProps.property.apiProps">apiProps</a></code> | <code>aws-cdk-lib.aws_apigatewayv2.WebSocketApiProps</code> | *No description.* |

---

##### `apiName`<sup>Required</sup> <a name="apiName" id="must-cdk.WebSocketApiProps.property.apiName"></a>

```typescript
public readonly apiName: string;
```

- *Type:* string

---

##### `apiProps`<sup>Optional</sup> <a name="apiProps" id="must-cdk.WebSocketApiProps.property.apiProps"></a>

```typescript
public readonly apiProps: WebSocketApiProps;
```

- *Type:* aws-cdk-lib.aws_apigatewayv2.WebSocketApiProps

---

### WebSocketRoute <a name="WebSocketRoute" id="must-cdk.WebSocketRoute"></a>

#### Initializer <a name="Initializer" id="must-cdk.WebSocketRoute.Initializer"></a>

```typescript
import { WebSocketRoute } from 'must-cdk'

const webSocketRoute: WebSocketRoute = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#must-cdk.WebSocketRoute.property.handler">handler</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketRoute.property.routeKey">routeKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#must-cdk.WebSocketRoute.property.routeResponseSelectionExpression">routeResponseSelectionExpression</a></code> | <code>string</code> | *No description.* |

---

##### `handler`<sup>Required</sup> <a name="handler" id="must-cdk.WebSocketRoute.property.handler"></a>

```typescript
public readonly handler: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

##### `routeKey`<sup>Required</sup> <a name="routeKey" id="must-cdk.WebSocketRoute.property.routeKey"></a>

```typescript
public readonly routeKey: string;
```

- *Type:* string

---

##### `routeResponseSelectionExpression`<sup>Optional</sup> <a name="routeResponseSelectionExpression" id="must-cdk.WebSocketRoute.property.routeResponseSelectionExpression"></a>

```typescript
public readonly routeResponseSelectionExpression: string;
```

- *Type:* string

---

## Classes <a name="Classes" id="Classes"></a>

### ApiGatewayFactory <a name="ApiGatewayFactory" id="must-cdk.ApiGatewayFactory"></a>

Factory class for common API Gateway patterns.

#### Initializers <a name="Initializers" id="must-cdk.ApiGatewayFactory.Initializer"></a>

```typescript
import { ApiGatewayFactory } from 'must-cdk'

new ApiGatewayFactory()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.ApiGatewayFactory.createManualRoutesApi">createManualRoutesApi</a></code> | Create a manual routes API with common defaults. |
| <code><a href="#must-cdk.ApiGatewayFactory.createRoute">createRoute</a></code> | Helper to create CustomRoute with API key requirement. |
| <code><a href="#must-cdk.ApiGatewayFactory.createSimpleProxyApi">createSimpleProxyApi</a></code> | Create a simple proxy API with common defaults. |

---

##### `createManualRoutesApi` <a name="createManualRoutesApi" id="must-cdk.ApiGatewayFactory.createManualRoutesApi"></a>

```typescript
import { ApiGatewayFactory } from 'must-cdk'

ApiGatewayFactory.createManualRoutesApi(scope: Construct, id: string, primaryLambda: IFunction, routes: CustomRoute[], domainName?: string, hostedZone?: IHostedZone)
```

Create a manual routes API with common defaults.

###### `scope`<sup>Required</sup> <a name="scope" id="must-cdk.ApiGatewayFactory.createManualRoutesApi.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="must-cdk.ApiGatewayFactory.createManualRoutesApi.parameter.id"></a>

- *Type:* string

---

###### `primaryLambda`<sup>Required</sup> <a name="primaryLambda" id="must-cdk.ApiGatewayFactory.createManualRoutesApi.parameter.primaryLambda"></a>

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

###### `routes`<sup>Required</sup> <a name="routes" id="must-cdk.ApiGatewayFactory.createManualRoutesApi.parameter.routes"></a>

- *Type:* <a href="#must-cdk.CustomRoute">CustomRoute</a>[]

---

###### `domainName`<sup>Optional</sup> <a name="domainName" id="must-cdk.ApiGatewayFactory.createManualRoutesApi.parameter.domainName"></a>

- *Type:* string

---

###### `hostedZone`<sup>Optional</sup> <a name="hostedZone" id="must-cdk.ApiGatewayFactory.createManualRoutesApi.parameter.hostedZone"></a>

- *Type:* aws-cdk-lib.aws_route53.IHostedZone

---

##### `createRoute` <a name="createRoute" id="must-cdk.ApiGatewayFactory.createRoute"></a>

```typescript
import { ApiGatewayFactory } from 'must-cdk'

ApiGatewayFactory.createRoute(path: string, method: string, handler: IFunction, requireApiKey?: boolean)
```

Helper to create CustomRoute with API key requirement.

###### `path`<sup>Required</sup> <a name="path" id="must-cdk.ApiGatewayFactory.createRoute.parameter.path"></a>

- *Type:* string

---

###### `method`<sup>Required</sup> <a name="method" id="must-cdk.ApiGatewayFactory.createRoute.parameter.method"></a>

- *Type:* string

---

###### `handler`<sup>Required</sup> <a name="handler" id="must-cdk.ApiGatewayFactory.createRoute.parameter.handler"></a>

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

###### `requireApiKey`<sup>Optional</sup> <a name="requireApiKey" id="must-cdk.ApiGatewayFactory.createRoute.parameter.requireApiKey"></a>

- *Type:* boolean

---

##### `createSimpleProxyApi` <a name="createSimpleProxyApi" id="must-cdk.ApiGatewayFactory.createSimpleProxyApi"></a>

```typescript
import { ApiGatewayFactory } from 'must-cdk'

ApiGatewayFactory.createSimpleProxyApi(scope: Construct, id: string, lambdaFunction: IFunction, domainName?: string, hostedZone?: IHostedZone)
```

Create a simple proxy API with common defaults.

###### `scope`<sup>Required</sup> <a name="scope" id="must-cdk.ApiGatewayFactory.createSimpleProxyApi.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="must-cdk.ApiGatewayFactory.createSimpleProxyApi.parameter.id"></a>

- *Type:* string

---

###### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="must-cdk.ApiGatewayFactory.createSimpleProxyApi.parameter.lambdaFunction"></a>

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

###### `domainName`<sup>Optional</sup> <a name="domainName" id="must-cdk.ApiGatewayFactory.createSimpleProxyApi.parameter.domainName"></a>

- *Type:* string

---

###### `hostedZone`<sup>Optional</sup> <a name="hostedZone" id="must-cdk.ApiGatewayFactory.createSimpleProxyApi.parameter.hostedZone"></a>

- *Type:* aws-cdk-lib.aws_route53.IHostedZone

---



### WebSocketApiGatewayFactory <a name="WebSocketApiGatewayFactory" id="must-cdk.WebSocketApiGatewayFactory"></a>

Factory class for common WebSocket API Gateway patterns.

#### Initializers <a name="Initializers" id="must-cdk.WebSocketApiGatewayFactory.Initializer"></a>

```typescript
import { WebSocketApiGatewayFactory } from 'must-cdk'

new WebSocketApiGatewayFactory()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#must-cdk.WebSocketApiGatewayFactory.createCommonRoutes">createCommonRoutes</a></code> | Create common WebSocket routes (connect, disconnect, default). |
| <code><a href="#must-cdk.WebSocketApiGatewayFactory.createRoute">createRoute</a></code> | Helper to create WebSocket route. |
| <code><a href="#must-cdk.WebSocketApiGatewayFactory.createSimpleWebSocketApi">createSimpleWebSocketApi</a></code> | Create a simple WebSocket API with common defaults. |
| <code><a href="#must-cdk.WebSocketApiGatewayFactory.createWebSocketApiWithRoutes">createWebSocketApiWithRoutes</a></code> | Create a WebSocket API with custom routes. |

---

##### `createCommonRoutes` <a name="createCommonRoutes" id="must-cdk.WebSocketApiGatewayFactory.createCommonRoutes"></a>

```typescript
import { WebSocketApiGatewayFactory } from 'must-cdk'

WebSocketApiGatewayFactory.createCommonRoutes(connectHandler: IFunction, disconnectHandler: IFunction, defaultHandler: IFunction)
```

Create common WebSocket routes (connect, disconnect, default).

###### `connectHandler`<sup>Required</sup> <a name="connectHandler" id="must-cdk.WebSocketApiGatewayFactory.createCommonRoutes.parameter.connectHandler"></a>

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

###### `disconnectHandler`<sup>Required</sup> <a name="disconnectHandler" id="must-cdk.WebSocketApiGatewayFactory.createCommonRoutes.parameter.disconnectHandler"></a>

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

###### `defaultHandler`<sup>Required</sup> <a name="defaultHandler" id="must-cdk.WebSocketApiGatewayFactory.createCommonRoutes.parameter.defaultHandler"></a>

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

##### `createRoute` <a name="createRoute" id="must-cdk.WebSocketApiGatewayFactory.createRoute"></a>

```typescript
import { WebSocketApiGatewayFactory } from 'must-cdk'

WebSocketApiGatewayFactory.createRoute(routeKey: string, handler: IFunction, routeResponseSelectionExpression?: string)
```

Helper to create WebSocket route.

###### `routeKey`<sup>Required</sup> <a name="routeKey" id="must-cdk.WebSocketApiGatewayFactory.createRoute.parameter.routeKey"></a>

- *Type:* string

---

###### `handler`<sup>Required</sup> <a name="handler" id="must-cdk.WebSocketApiGatewayFactory.createRoute.parameter.handler"></a>

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

###### `routeResponseSelectionExpression`<sup>Optional</sup> <a name="routeResponseSelectionExpression" id="must-cdk.WebSocketApiGatewayFactory.createRoute.parameter.routeResponseSelectionExpression"></a>

- *Type:* string

---

##### `createSimpleWebSocketApi` <a name="createSimpleWebSocketApi" id="must-cdk.WebSocketApiGatewayFactory.createSimpleWebSocketApi"></a>

```typescript
import { WebSocketApiGatewayFactory } from 'must-cdk'

WebSocketApiGatewayFactory.createSimpleWebSocketApi(scope: Construct, id: string, lambdaFunction: IFunction, domainName?: string, hostedZone?: IHostedZone)
```

Create a simple WebSocket API with common defaults.

###### `scope`<sup>Required</sup> <a name="scope" id="must-cdk.WebSocketApiGatewayFactory.createSimpleWebSocketApi.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="must-cdk.WebSocketApiGatewayFactory.createSimpleWebSocketApi.parameter.id"></a>

- *Type:* string

---

###### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="must-cdk.WebSocketApiGatewayFactory.createSimpleWebSocketApi.parameter.lambdaFunction"></a>

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

###### `domainName`<sup>Optional</sup> <a name="domainName" id="must-cdk.WebSocketApiGatewayFactory.createSimpleWebSocketApi.parameter.domainName"></a>

- *Type:* string

---

###### `hostedZone`<sup>Optional</sup> <a name="hostedZone" id="must-cdk.WebSocketApiGatewayFactory.createSimpleWebSocketApi.parameter.hostedZone"></a>

- *Type:* aws-cdk-lib.aws_route53.IHostedZone

---

##### `createWebSocketApiWithRoutes` <a name="createWebSocketApiWithRoutes" id="must-cdk.WebSocketApiGatewayFactory.createWebSocketApiWithRoutes"></a>

```typescript
import { WebSocketApiGatewayFactory } from 'must-cdk'

WebSocketApiGatewayFactory.createWebSocketApiWithRoutes(scope: Construct, id: string, defaultHandler: IFunction, routes: WebSocketRoute[], domainName?: string, hostedZone?: IHostedZone)
```

Create a WebSocket API with custom routes.

###### `scope`<sup>Required</sup> <a name="scope" id="must-cdk.WebSocketApiGatewayFactory.createWebSocketApiWithRoutes.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="must-cdk.WebSocketApiGatewayFactory.createWebSocketApiWithRoutes.parameter.id"></a>

- *Type:* string

---

###### `defaultHandler`<sup>Required</sup> <a name="defaultHandler" id="must-cdk.WebSocketApiGatewayFactory.createWebSocketApiWithRoutes.parameter.defaultHandler"></a>

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

###### `routes`<sup>Required</sup> <a name="routes" id="must-cdk.WebSocketApiGatewayFactory.createWebSocketApiWithRoutes.parameter.routes"></a>

- *Type:* <a href="#must-cdk.WebSocketRoute">WebSocketRoute</a>[]

---

###### `domainName`<sup>Optional</sup> <a name="domainName" id="must-cdk.WebSocketApiGatewayFactory.createWebSocketApiWithRoutes.parameter.domainName"></a>

- *Type:* string

---

###### `hostedZone`<sup>Optional</sup> <a name="hostedZone" id="must-cdk.WebSocketApiGatewayFactory.createWebSocketApiWithRoutes.parameter.hostedZone"></a>

- *Type:* aws-cdk-lib.aws_route53.IHostedZone

---




